/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.core;

import java.io.InputStream;
import java.util.Date;
import com.silverwrist.venice.except.AccessError;
import com.silverwrist.venice.except.DataException;

public interface TopicMessageContext
{
  public abstract long getPostID();

  public abstract long getParentPostID();

  public abstract int getPostNumber();

  public abstract int getNumLines();

  public abstract int getCreatorUID();

  public abstract String getCreatorName() throws DataException;

  public abstract Date getPostDate();

  public abstract boolean isHidden();

  public abstract boolean isScribbled();

  public abstract boolean isNuked();

  public abstract Date getScribbleDate();

  public abstract String getPseud();

  public abstract String getBodyText() throws DataException;

  public abstract boolean hasAttachment();

  public abstract String getAttachmentType();

  public abstract String getAttachmentFilename();

  public abstract int getAttachmentLength();

  public abstract InputStream getAttachmentData() throws AccessError, DataException;

  public abstract boolean canHide();

  public abstract boolean canScribble();

  public abstract boolean canNuke();

  public abstract void setHidden(boolean flag) throws DataException, AccessError;

  public abstract void scribble() throws DataException, AccessError;

  public abstract void nuke() throws DataException, AccessError;

  public abstract void attachData(String m_type, String file, int length, InputStream data)
      throws AccessError, DataException;

  public abstract void attachData(String m_type, String file, byte[] data) throws AccessError, DataException;

  public abstract boolean canPublish();

  public abstract void publish() throws DataException, AccessError;

  public abstract TopicContext getEnclosingTopic() throws DataException;

  public abstract String getPostLink() throws DataException;

  public abstract void moveToTopic(int newtopicid) throws DataException, AccessError;

  public abstract boolean canMove();

} // end interface TopicMessageContext
